#!/bin/sh
# Wiwiz HotSpot Builder Utility
# Copyright wiwiz.com. All rights reserved.

DEST=""
OS=""
WIFIDOG_START="wifidog"

LOGFILE='/tmp/hsbuilder.log'

if [ "$1" = "-os" ]; then
	if [ "$2" = "openwrt" ]; then
		WIFIDOG_START="wifidog-init start"
	elif [ "$2" = "dd-wrt" ]; then
		WIFIDOG_START="wifidog"
	elif [ "$2" = "linux" ]; then
		WIFIDOG_START="/usr/local/bin/wifidog -c /etc/wifidog.conf"
	fi
	OS="$2"
	
	shift 2
fi

if [ "$1" = "-dest" ]; then
	if [ ! -d "$2" -a "$2" != "" ]; then
		echo "Error: $2 does not exist!"
		exit 1
	else
		DEST="$2"
	fi
	shift 2
fi


CONFPATH=$DEST'/usr/local/hsbuilder/hsbuilder.conf'

WIFIDOG_CONFPATH=$(cat $CONFPATH | grep -v "^#" | grep WIFIDOG_CONFPATH | cut -d = -f 2)

wdctl status
CODE="$?"

if [ $CODE != "0" ]; then
	if [ $OS != "linux" ]; then	
		cp -f $DEST/usr/local/hsbuilder/wifidog.conf $WIFIDOG_CONFPATH/wifidog.conf
	fi
	$WIFIDOG_START
	echo "Helper: $(date) Wifidog not running! Started." >>$LOGFILE
	exit 0
fi

exit 1